diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/three-gpp-channel-model.cc ns-3.42/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.41/src/spectrum/model/three-gpp-channel-model.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/three-gpp-channel-model.cc	2024-05-29 15:29:47.172073600 -0700
@@ -1045,6 +1886,538 @@
             NS_FATAL_ERROR("Unknown channel condition");
         }
     }
+    else if (m_scenario.substr(0, 3) == "NTN")
+    {
+        std::string freqBand = (fcGHz < 13) ? "S" : "Ka";
+
+        double elevAngle = 0;
+        bool isSatellite = false; // flag to indicate if one of the two nodes is a satellite
+                                  // if so, parameters will be set accordingly to NOTE 8 of
+                                  // Table 6.7.2 from 3GPP 38.811 V15.4.0 (2020-09)
+
+        Ptr<MobilityModel> aMobNonConst = ConstCast<MobilityModel>(aMob);
+        Ptr<MobilityModel> bMobNonConst = ConstCast<MobilityModel>(bMob);
+
+        if (DynamicCast<GeocentricConstantPositionMobilityModel>(
+                ConstCast<MobilityModel>(aMob)) && // Transform to NS_ASSERT
+            DynamicCast<GeocentricConstantPositionMobilityModel>(
+                ConstCast<MobilityModel>(bMob))) // check if aMob and bMob are of type
+                                                 // GeocentricConstantPositionMobilityModel
+        {
+            Ptr<GeocentricConstantPositionMobilityModel> aNTNMob =
+                DynamicCast<GeocentricConstantPositionMobilityModel>(aMobNonConst);
+            Ptr<GeocentricConstantPositionMobilityModel> bNTNMob =
+                DynamicCast<GeocentricConstantPositionMobilityModel>(bMobNonConst);
+
+            if (aNTNMob->GetGeographicPosition().z <
+                bNTNMob->GetGeographicPosition().z) // b is the HAPS/Satellite
+            {
+                elevAngle = aNTNMob->GetElevationAngle(bNTNMob);
+                if (bNTNMob->GetGeographicPosition().z > 50000)
+                {
+                    isSatellite = true;
+                }
+            }
+            else // a is the HAPS/Satellite
+            {
+                elevAngle = bNTNMob->GetElevationAngle(aNTNMob);
+                if (aNTNMob->GetGeographicPosition().z > 50000)
+                {
+                    isSatellite = true;
+                }
+            }
+        }
+        else
+        {
+            NS_FATAL_ERROR("Mobility Models needs to be of type Geocentric for NTN scenarios");
+        }
+
+        // Round the elevation angle into a two-digits integer between 10 and 90.
+        int elevAngleQuantized = (elevAngle < 10) ? 10 : round(elevAngle / 10) * 10;
+
+        if (m_scenario == "NTN-DenseUrban")
+        {
+            if (channelCondition->IsLos())
+            {
+                table3gpp->m_uLgDS =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+
+                // table3gpp->m_uLgASD=-1.79769e+308;  //FOR SATELLITES
+                table3gpp->m_uLgASD =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                // table3gpp->m_sigLgASD=0; //FOR SATELLITES
+                table3gpp->m_sigLgASD =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
+
+                table3gpp->m_uLgASA =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
+
+                // table3gpp->m_uLgZSD=-1.79769e+308;  //FOR SATELLITES
+                table3gpp->m_uLgZSD =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                // table3gpp->m_sigLgZSD= 0; //FOR SATELLITES
+                table3gpp->m_sigLgZSD =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
+
+                table3gpp->m_uK =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
+                table3gpp->m_sigK =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
+                table3gpp->m_rTau =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster = NTNDenseUrbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNDenseUrbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNDenseUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNDenseUrbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                for (uint8_t row = 0; row < 7; row++)
+                {
+                    for (uint8_t column = 0; column < 7; column++)
+                    {
+                        table3gpp->m_sqrtC[row][column] = sqrtC_NTN_DenseUrban_LOS[row][column];
+                    }
+                }
+            }
+            else if (channelCondition->IsNlos())
+            {
+                NS_LOG_UNCOND("Dense Urban NLOS");
+                table3gpp->m_uLgDS =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+                table3gpp->m_uLgASD =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                table3gpp->m_sigLgASD = NTNDenseUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::sigLgASD];
+                table3gpp->m_uLgASA =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA = NTNDenseUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA = NTNDenseUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::sigLgZSA];
+                table3gpp->m_uLgZSD =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                table3gpp->m_sigLgZSD = NTNDenseUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::sigLgZSD];
+                table3gpp->m_rTau =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster = NTNDenseUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNDenseUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNDenseUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNDenseUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                for (uint8_t row = 0; row < 6; row++)
+                {
+                    for (uint8_t column = 0; column < 6; column++)
+                    {
+                        table3gpp->m_sqrtC[row][column] = sqrtC_NTN_DenseUrban_NLOS[row][column];
+                    }
+                }
+            }
+        }
+        else if (m_scenario == "NTN-Urban")
+        {
+            if (channelCondition->IsLos())
+            {
+                table3gpp->m_uLgDS =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+                table3gpp->m_uLgASD =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                table3gpp->m_sigLgASD =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
+                table3gpp->m_uLgASA =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
+                table3gpp->m_uLgZSD =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                table3gpp->m_sigLgZSD =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
+                table3gpp->m_uK =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
+                table3gpp->m_sigK =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
+                table3gpp->m_rTau =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNUrbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNUrbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNUrbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                for (uint8_t row = 0; row < 7; row++)
+                {
+                    for (uint8_t column = 0; column < 7; column++)
+                    {
+                        table3gpp->m_sqrtC[row][column] = sqrtC_NTN_Urban_LOS[row][column];
+                    }
+                }
+            }
+            else if (channelCondition->IsNlos())
+            {
+                table3gpp->m_uLgDS =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+                table3gpp->m_uLgASD =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                table3gpp->m_sigLgASD =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
+                table3gpp->m_uLgASA =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
+                table3gpp->m_uLgZSD =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                table3gpp->m_sigLgZSD =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
+                table3gpp->m_uK =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
+                table3gpp->m_sigK =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
+                table3gpp->m_rTau =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNUrbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNUrbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                for (uint8_t row = 0; row < 6; row++)
+                {
+                    for (uint8_t column = 0; column < 6; column++)
+                    {
+                        table3gpp->m_sqrtC[row][column] =
+                            sqrtC_NTN_Urban_NLOS.at(elevAngleQuantized)[row][column];
+                    }
+                }
+            }
+        }
+        else if (m_scenario == "NTN-Suburban")
+        {
+            if (channelCondition->IsLos())
+            {
+                table3gpp->m_uLgDS =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+                table3gpp->m_uLgASD =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                table3gpp->m_sigLgASD =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
+                table3gpp->m_uLgASA =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
+                table3gpp->m_uLgZSD =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                table3gpp->m_sigLgZSD =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
+                table3gpp->m_uK =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
+                table3gpp->m_sigK =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
+                table3gpp->m_rTau =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster = NTNSuburbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNSuburbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNSuburbanLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNSuburbanLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                for (uint8_t row = 0; row < 7; row++)
+                {
+                    for (uint8_t column = 0; column < 7; column++)
+                    {
+                        table3gpp->m_sqrtC[row][column] = sqrtC_NTN_Suburban_LOS[row][column];
+                    }
+                }
+            }
+            else if (channelCondition->IsNlos())
+            {
+                table3gpp->m_uLgDS =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+                table3gpp->m_uLgASD =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                table3gpp->m_sigLgASD =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
+                table3gpp->m_uLgASA =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
+                table3gpp->m_uLgZSD =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                table3gpp->m_sigLgZSD =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
+                table3gpp->m_uK =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
+                table3gpp->m_sigK =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
+                table3gpp->m_rTau =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster = NTNSuburbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNSuburbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNSuburbanNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNSuburbanNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                for (uint8_t row = 0; row < 6; row++)
+                {
+                    for (uint8_t column = 0; column < 6; column++)
+                    {
+                        table3gpp->m_sqrtC[row][column] = sqrtC_NTN_Suburban_NLOS[row][column];
+                    }
+                }
+            }
+        }
+        else if (m_scenario == "NTN-Rural")
+        {
+            if (channelCondition->IsLos())
+            {
+                table3gpp->m_uLgDS =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+                table3gpp->m_uLgASD =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                table3gpp->m_sigLgASD =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
+                table3gpp->m_uLgASA =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
+                table3gpp->m_uLgZSD =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                table3gpp->m_sigLgZSD =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
+                table3gpp->m_uK =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
+                table3gpp->m_sigK =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
+                table3gpp->m_rTau =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNRuralLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNRuralLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNRuralLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                for (uint8_t row = 0; row < 7; row++)
+                {
+                    for (uint8_t column = 0; column < 7; column++)
+                    {
+                        table3gpp->m_sqrtC[row][column] = sqrtC_NTN_Rural_LOS[row][column];
+                    }
+                }
+            }
+            else if (channelCondition->IsNlos())
+            {
+                table3gpp->m_uLgDS =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgDS];
+                table3gpp->m_sigLgDS =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgDS];
+                table3gpp->m_uLgASD =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASD];
+                table3gpp->m_sigLgASD =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASD];
+                table3gpp->m_uLgASA =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgASA];
+                table3gpp->m_sigLgASA =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgASA];
+                table3gpp->m_uLgZSA =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSA];
+                table3gpp->m_sigLgZSA =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSA];
+                table3gpp->m_uLgZSD =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uLgZSD];
+                table3gpp->m_sigLgZSD =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigLgZSD];
+                table3gpp->m_uK =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uK];
+                table3gpp->m_sigK =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigK];
+                table3gpp->m_rTau =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::rTau];
+                table3gpp->m_uXpr =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::uXpr];
+                table3gpp->m_sigXpr =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::sigXpr];
+                table3gpp->m_numOfCluster =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::numOfCluster];
+                table3gpp->m_raysPerCluster = NTNRuralNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::raysPerCluster];
+                table3gpp->m_cDS =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cDS];
+                table3gpp->m_cASD =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASD];
+                table3gpp->m_cASA =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cASA];
+                table3gpp->m_cZSA =
+                    NTNRuralNLOS.at(freqBand).at(elevAngleQuantized)[Table3gppParams::cZSA];
+                table3gpp->m_perClusterShadowingStd = NTNRuralNLOS.at(freqBand).at(
+                    elevAngleQuantized)[Table3gppParams::perClusterShadowingStd];
+
+                if (freqBand == "S")
+                {
+                    for (uint8_t row = 0; row < 6; row++)
+                    {
+                        for (uint8_t column = 0; column < 6; column++)
+                        {
+                            table3gpp->m_sqrtC[row][column] =
+                                sqrtC_NTN_Rural_NLOS_S.at(elevAngleQuantized)[row][column];
+                        }
+                    }
+                }
+                else if (freqBand == "Ka")
+                {
+                    for (uint8_t row = 0; row < 6; row++)
+                    {
+                        for (uint8_t column = 0; column < 6; column++)
+                        {
+                            table3gpp->m_sqrtC[row][column] =
+                                sqrtC_NTN_Rural_NLOS_Ka.at(elevAngleQuantized)[row][column];
+                        }
+                    }
+                }
+            }
+        }
+        // Parameters that should be set to -inf are instead set to the minimum
+        // value of double
+        if (isSatellite)
+        {
+            table3gpp->m_uLgASD = std::numeric_limits<double>::min();
+            table3gpp->m_sigLgASD = 0;
+            table3gpp->m_uLgZSD = std::numeric_limits<double>::min();
+            table3gpp->m_sigLgZSD = 0;
+        }
+    }
     else
     {
         NS_FATAL_ERROR("unknown scenarios");
